Coin: SoReversePerspectiveCamera Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

SoReversePerspectiveCamera Class Reference
Node Classes

The SoReversePerspectiveCamera class defines a camera node with reverse perspective rendering. More...

`#include <Inventor/nodes/SoReversePerspectiveCamera.h>`

Inheritance diagram for SoReversePerspectiveCamera:

## Public Member Functions
virtual SoType | getTypeId (void) const
| SoReversePerspectiveCamera (void)
Public Member Functions inherited from SoPerspectiveCamera
| SoPerspectiveCamera (void)
virtual void | scaleHeight (float scalefactor)
virtual SbViewVolume | getViewVolume (float useaspectratio=0.0f) const
virtual void | viewBoundingBox (const SbBox3f &box, float aspect, float slack)
Public Member Functions inherited from SoCamera
SbViewVolume | getViewVolume (const SbViewportRegion &vp, SbViewportRegion &resultvp, const SbMatrix &mm=SbMatrix::identity()) const
void | pointAt (const SbVec3f &targetpoint)
void | pointAt (const SbVec3f &targetpoint, const SbVec3f &upvector)
void | viewAll (SoNode *const sceneroot, const SbViewportRegion &vpregion, const float slack=1.0f)
void | viewAll (SoPath *const path, const SbViewportRegion &vpregion, const float slack=1.0f)
SbViewportRegion | getViewportBounds (const SbViewportRegion &region) const
void | setStereoMode (StereoMode mode)
StereoMode | getStereoMode (void) const
void | setStereoAdjustment (float adjustment)
float | getStereoAdjustment (void) const
void | setBalanceAdjustment (float adjustment)
float | getBalanceAdjustment (void) const
virtual void | doAction (SoAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | pick (SoPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
SbUniqueId | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoPerspectiveCamera
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoCamera
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Protected Member Functions
virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoReversePerspectiveCamera ()
Protected Member Functions inherited from SoPerspectiveCamera
virtual | ~SoPerspectiveCamera ()
Protected Member Functions inherited from SoCamera
| SoCamera (void)
virtual | ~SoCamera ()
virtual void | jitter (int numpasses, int curpass, const SbViewportRegion &vpreg, SbVec3f &jitteramount) const
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoPerspectiveCamera
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoCamera
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members
Public Types inherited from SoCamera
enum | ViewportMapping { CROP_VIEWPORT_FILL_FRAME , CROP_VIEWPORT_LINE_FRAME , CROP_VIEWPORT_NO_FRAME , ADJUST_CAMERA , LEAVE_ALONE }
enum | StereoMode { MONOSCOPIC , LEFT_VIEW , RIGHT_VIEW }
Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 , INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 , COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 , COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 , COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000 }
Public Attributes inherited from SoPerspectiveCamera
SoSFFloat | heightAngle
Public Attributes inherited from SoCamera
SoSFEnum | viewportMapping
SoSFVec3f | position
SoSFRotation | orientation
SoSFFloat | aspectRatio
SoSFFloat | nearDistance
SoSFFloat | farDistance
SoSFFloat | focalDistance
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoReversePerspectiveCamera class defines a camera node with reverse perspective rendering.

For realistic looking 3D scene, the geometry should be rendered with perspective calculations. Use this camera type to accomplish this.

Reverse perspective rendering, a special case of perspective rendering, is where the projection rays do not converge in the eye of the observer, but instead at a point behind the scene. Thus objects farther away from the observer appear larger than closer objects. A reverse perspective projection is defined by

- setting the perspective camera position to the projection point behind the scene
- setting near / far distance to negative values
- rotating the camera orientation by 180 degrees around the camera Z-axis to compensate the image flip induced by the negative near / far values.

The view volume of the default reverse perspective camera is defined as shown below.

FILE FORMAT/DEFAULTS:

ReversePerspectiveCamera {
viewportMapping ADJUST_CAMERA
position 0 0 -10
orientation 0 0 1 3.14159
nearDistance -10
farDistance -1
aspectRatio 1
focalDistance -6
heightAngle 0.78539819
}
SoCamera::position
SoSFVec3f position
Definition SoCamera.h:81
SoCamera::orientation
SoSFRotation orientation
Definition SoCamera.h:82
SoCamera::farDistance
SoSFFloat farDistance
Definition SoCamera.h:85
SoCamera::aspectRatio
SoSFFloat aspectRatio
Definition SoCamera.h:83
SoCamera::focalDistance
SoSFFloat focalDistance
Definition SoCamera.h:86
SoCamera::nearDistance
SoSFFloat nearDistance
Definition SoCamera.h:84
SoCamera::viewportMapping
SoSFEnum viewportMapping
Definition SoCamera.h:80
SoPerspectiveCamera::heightAngle
SoSFFloat heightAngle
Definition SoPerspectiveCamera.h:48

## Constructor & Destructor Documentation

## ◆ SoReversePerspectiveCamera()

SoReversePerspectiveCamera::SoReversePerspectiveCamera | ( | void |  | ) |

Constructor.

## ◆ ~SoReversePerspectiveCamera()

SoReversePerspectiveCamera::~SoReversePerspectiveCamera | ( |  | ) |
| protectedvirtual

Destructor.

## Member Function Documentation

## ◆ getClassTypeId()

SoType SoReversePerspectiveCamera::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ getTypeId()

SoType SoReversePerspectiveCamera::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Reimplemented from SoPerspectiveCamera.

## ◆ getFieldDataPtr()

const SoFieldData ** SoReversePerspectiveCamera::getFieldDataPtr | ( | void |  | ) |
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## ◆ getFieldData()

const SoFieldData * SoReversePerspectiveCamera::getFieldData | ( | void |  | ) | const
| protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoPerspectiveCamera.

The documentation for this class was generated from the following files:

- SoReversePerspectiveCamera.h
- SoReversePerspectiveCamera.cpp